__gnu_parallel::_LoserTree< __stable, _Tp, _Compare > Class Template Reference

`#include <losertree.h>`

Inheritance diagram for __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >:
[legend]

## Public Member Functions

| _LoserTree (unsigned int __k, _Compare __comp)
void | __delete_min_insert (_Tp __key, bool __sup)
int | __get_min_source ()
void | __init ()
unsigned int | __init_winner (unsigned int __root)
void | __insert_start (const _Tp &__key, int __source, bool __sup)

## Protected Attributes

unsigned int | _M_ik
unsigned int | _M_log_k
unsigned int | _M_offset

## Detailed Description

template<bool __stable, typename _Tp, typename _Compare>
class __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >

Stable _LoserTree variant.

Provides the stable implementations of insert_start, __init_winner, __init and __delete_min_insert.

Unstable variant is done using partial specialisation below.

Definition at line 169 of file losertree.h.

## Constructor & Destructor Documentation

## _LoserTree()

template<bool __stable, typename _Tp , typename _Compare >

__gnu_parallel::_LoserTree< __stable, _Tp, _Compare >::_LoserTree | ( | unsigned int | __k,
|  | _Compare | __comp
| ) |  |

inline

Definition at line 179 of file losertree.h.

## Member Function Documentation

## __delete_min_insert()

template<bool __stable, typename _Tp , typename _Compare >

void __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >::__delete_min_insert | ( | _Tp | __key,
|  | bool | __sup
| ) |  |

inline

Delete the smallest element and insert a new element from the previously smallest element's sequence.

This implementation is stable.

Definition at line 222 of file losertree.h.

References std::swap().

## __get_min_source()

template<typename _Tp , typename _Compare >

int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__get_min_source | ( |  | ) |

inline inherited

Returns
  the index of the sequence with the smallest element.

Definition at line 155 of file losertree.h.

References __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_losers, and __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_source.

## __init()

template<bool __stable, typename _Tp , typename _Compare >

void __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >::__init | ( |  | ) |

inline

Definition at line 210 of file losertree.h.

## __init_winner()

template<bool __stable, typename _Tp , typename _Compare >

unsigned int __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >::__init_winner | ( | unsigned int | __root | ) |

inline

Definition at line 184 of file losertree.h.

## __insert_start()

template<typename _Tp , typename _Compare >

void __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__insert_start | ( | const _Tp & | __key,
|  | int | __source,
|  | bool | __sup
| ) |  |

inline inherited

Initializes the sequence "_M_source" with the element "__key".

Parameters

  __key | the element to insert
  __source | __index of the __source __sequence
  __sup | flag that determines whether the value to insert is an explicit __supremum.

Definition at line 134 of file losertree.h.

References __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_first_insert, __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_key, __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_losers, __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_source, and __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_sup.

## Member Data Documentation

## _M_ik

template<typename _Tp , typename _Compare >

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_ik

protected inherited

Definition at line 69 of file losertree.h.

## _M_log_k

template<typename _Tp , typename _Compare >

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_log_k

protected inherited

log_2{_M_k}

Definition at line 72 of file losertree.h.

Referenced by __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_LoserTreeBase().

## _M_offset

template<typename _Tp , typename _Compare >

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_offset

protected inherited

Definition at line 69 of file losertree.h.

The documentation for this class was generated from the following file:

- losertree.h